Subject: Re: [bug#68498] [PATCH] guix-install.sh: Make Guix modules available too.

From: Ludovic Courtès <[email-masked]>
Date: Mon, 29 Jan 2024 12:22:13 +0100

Hi,

Janneke Nieuwenhuizen <[email-masked]> skribis:

>>> +# Make Guix modules available
>>> +export GUILE_LOAD_PATH="$_GUIX_PROFILE/share/guile/site/3.0${GUILE_LOAD_PATH:+:}$GUILE_LOAD_PATH"
>>> +export GUILE_LOAD_COMPILED_PATH="$_GUIX_PROFILE/lib/guile/3.0/site-ccache${GUILE_LOAD_COMPILED_PATH:+:}$GUILE_LOAD_COMPILED_PATH"
>>
>> My inclination would be to let people just use ‘guix repl’, but maybe
>> that’s not satisfactory or convenient?  WDYT?
>
> The intention is to have the foreign distro experience resemble Guix
> System more, esp. for newbee users.  If you have a code base that uses
> Guix modules and comes with a guix.scm, running "guix shell" doesn't
> work for them.  Unless, maybe, you add "guix" to the package's
> native-inputs -- yuck.

Packages that extend Guix functionality, like Cuirass and hpcguix-web,
have ‘guix’ in their inputs.  That’s fine: they use just the core (guix …)
modules to interact with the store etc.

Is that what the kind of use case you had in mind?

> They'd have to probably do something guix time-machine --channel=xxx to
> get access to guix modules.  That, or source a script that set the
> environment variables, which is what we let them do currently.  I was
> guessing "everyone" is probably fighting with this, so finally decided
> to upstream it :)
>
> If there's a better/easier solution for this, I'm all ears!

I don’t think one needs ‘guix time-machine’; ‘guix repl’ is enough to
get access to Guix modules.

But maybe I’m missing something?

Thanks,
Ludo’.